import("./utils.js").then((utils) => {
  import(utils.coreVersion()).then((core) => {

    core.Sib.register({
      name: "customtzcld-display-community-widget",
      use: [core.StoreMixin],

      empty() {
        this.element.innerHTML = "";
      },

      async populate() {
        this.element.innerHTML = `
        <div class="loader">
          <div></div>
          <div></div>
          <div></div>
          <div></div>
        </div>`;
        let tzcldprofile = {
          contact_first_name: await this.resource.contact_first_name,
          contact_last_name: await this.resource.contact_last_name,
          contact_job: await this.resource.contact_job,
          kind: await this.resource.kind,
          features: await this.resource.features,
          region: await this.resource.region,
          contact_mail_1: await this.resource.contact_mail_1,
          contact_mail_2: await this.resource.contact_mail_2,
          contact_mail_3: await this.resource.contact_mail_3,
          membership: await this.resource.membership,
          last_contribution_year: await this.resource.last_contribution_year
        };
        if("label" in this.element.attributes) {
          for(let ignore of this.element.attributes['label'].value.split(',')) {
            tzcldprofile[ignore.trim()] = null;
          }
        }
        let render = "<div class='border-top margin-medium border-color-grey'></div>";
        if(tzcldprofile.features) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Caractéristiques</span>:&nbsp;${tzcldprofile.features}</div>`;
        }
        if(tzcldprofile.region) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Région / Département</span>:&nbsp;${tzcldprofile.region}</div>`;
        }
        if(tzcldprofile.contact_mail_1) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Mail contact 1</span>:&nbsp;${tzcldprofile.contact_mail_1}</div>`;
        }
        if(tzcldprofile.contact_mail_2) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Mail contact 2</span>:&nbsp;${tzcldprofile.contact_mail_2}</div>`;
        }
        if(tzcldprofile.contact_mail_3) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Mail contact 3</span>:&nbsp;${tzcldprofile.contact_mail_3}</div>`;
        }
        if(tzcldprofile.contact_first_name || tzcldprofile.contact_last_name) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Personne de contact</span>:&nbsp;`;
          if(tzcldprofile.contact_first_name) render += `${tzcldprofile.contact_first_name}`;
          if(tzcldprofile.contact_last_name && tzcldprofile.contact_first_name) render += ` `;
          if(tzcldprofile.contact_last_name) render += `${tzcldprofile.contact_last_name}`;
          render += `</div>`;
        }
        if(tzcldprofile.contact_job) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Poste occupé par le contact</span>:&nbsp;${tzcldprofile.contact_job}</div>`;
        }
        if(tzcldprofile.kind) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Type de territoire</span>:&nbsp;${await tzcldprofile.kind['name']}</div>`;
        }
        if(tzcldprofile.membership) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Adhésion</span>:&nbsp;<input type="checkbox" checked disabled /></div>`;
        }
        if(!tzcldprofile.membership) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Adhésion</span>:&nbsp;<input type="checkbox" disabled /></div>`;
        }
        if(tzcldprofile.last_contribution_year) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Année dernière cotisation</span>:&nbsp;${tzcldprofile.last_contribution_year}</div>`;
        }
        render += "<div class='border-top margin-medium border-color-grey'></div>";
        this.element.innerHTML = render;
      },
    });

    core.Sib.register({
      name: "customtzcld-display-profile-widget",
      use: [core.StoreMixin],

      empty() {
        console.debug();
        this.element.innerHTML = "";
      },

      async populate() {
        this.element.innerHTML = `
        <div class="loader">
          <div></div>
          <div></div>
          <div></div>
          <div></div>
        </div>`;
        let tzcldprofile = {
          description: await this.resource.description,
          postal_code: await this.resource.postal_code,
          address: await this.resource.address,
          phone: await this.resource.phone,
          position: await this.resource.position,
          membership: await this.resource.membership,
          last_contribution_year: await this.resource.last_contribution_year,
          events: await this.resource["events.ldp:contains"],
          orgs: await this.resource["orgs.ldp:contains"],
          regions: await this.resource["regions.ldp:contains"]
        };
        if("label" in this.element.attributes) {
          for(let ignore of this.element.attributes['label'].value.split(',')) {
            tzcldprofile[ignore.trim()] = null;
          }
        }
        let render = "<div class='border-top margin-medium border-color-grey'></div>";
        if(tzcldprofile.description) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Description</span>:&nbsp;${tzcldprofile.description}</div>`;
        }
        if(tzcldprofile.regions && tzcldprofile.regions.length > 0) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Région / Département</span>:&nbsp;`;
          for(let region of tzcldprofile.regions) {
            render += `${await region['name']},&nbsp;`;
          }
          render = render.slice(0, -7);
          render += `</div>`;
        }
        if(tzcldprofile.postal_code) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Code postal</span>:&nbsp;${tzcldprofile.postal_code}</div>`;
        }
        if(tzcldprofile.address) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Adresse postale</span>:&nbsp;${tzcldprofile.address}</div>`;
        }
        if(tzcldprofile.events && tzcldprofile.events.length > 0) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Évènements marquants</span>:&nbsp;`;
          for(let event of tzcldprofile.events) {
            render += `${await event['name']},&nbsp;`;
          }
          render = render.slice(0, -7);
          render += `</div>`;
        }
        if(tzcldprofile.orgs && tzcldprofile.orgs.length > 0) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Organisation ou Territoire</span>:&nbsp;`;
          for(let org of tzcldprofile.orgs) {
            render += `${await org['name']},&nbsp;`;
          }
          render = render.slice(0, -7);
          render += `</div>`;
        }
        if(tzcldprofile.position) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Poste occupé</span>:&nbsp;${tzcldprofile.position}</div>`;
        }
        if(tzcldprofile.membership) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Adhésion</span>:&nbsp;<input type="checkbox" checked disabled /></div>`;
        }
        if(!tzcldprofile.membership) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Adhésion</span>:&nbsp;<input type="checkbox" disabled /></div>`;
        }
        if(tzcldprofile.last_contribution_year) {
          render += `<div class="segment block"><span class="text-semibold text-uppercase text-color-heading">Année dernière cotisation</span>:&nbsp;${tzcldprofile.last_contribution_year}</div>`;
        }
        render += "<div class='border-top margin-medium border-color-grey'></div>";
        this.element.innerHTML = render;
      },
    });

    customElements.define(
      "customtzcld-form-profile-jobs-widget-hook",
      class extends core.SolidTemplateElement {
        constructor() {
          super();
          this.loaderID = core.Helpers.uniqID();
        }

        static get propsDefinition() {
          return {
            dataSrc: 'data-src',
          };
        }
        template({dataSrc
        }) {
        return `
        <solid-widget name="customtzcld-form-profile-phone-widget">
        <template>
        <solid-form
        class="d-block rowClear"
        data-src="\${value}"
        data-holder
        partial
        naked
        fields="segment1(phone, phone_type, phone_public)"
        class-segment1="segment full sm-full rowClear"
        class-phone="segment margin-bottom-medium width-45 sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-phone_type="segment margin-bottom-medium width-45 sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-phone_public="segment margin-bottom-medium width-10 sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading  text-uppercase tzcld-checkbox"
        widget-phone_public="solid-form-checkbox-label"
        label-phone="Téléphone *"
        required-phone
        label-phone_type="Type de ligne"
        label-phone_public="Public"
      ></solid-form>
        </template>
        </solid-widget>
        <solid-widget name="customtzcld-form-profile-email-widget">
        <template>
        <solid-form
        class="d-block rowClear"
        data-src="\${value}"
        data-holder
        partial
        naked
        fields="segment1(email, email_type, email_public)"
        class-segment1="segment full sm-full rowClear"
        class-email="segment margin-bottom-medium width-45 sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-email_type="segment margin-bottom-medium width-45 sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-email_public="segment margin-bottom-medium width-10 sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading text-uppercase tzcld-checkbox"
        widget-email_public="solid-form-checkbox-label"
        label-email="E-mail *"
        required-email
        label-email_type="Type d'e-mail"
        label-email_public="Public"
      ></solid-form>
        </template>
        </solid-widget>
        <solid-widget name="customtzcld-form-profile-jobs-widget">
        <template>
        <solid-form
        class="d-block rowClear"
        data-src="\${value}"
        data-holder
        naked
        fields="segment11(position, organisation), segment12(address, postal_code), segment13(city, department, address_public), phones, emails"
        value-profile="\${value}"
        class-segment11="segment full sm-full rowClear"
        class-segment12="segment full sm-full rowClear"
        class-segment13="segment full sm-full rowClear"
        class-position="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-organisation="segment margin-bottom-medium half sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-address="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-postal_code="segment margin-bottom-medium half sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-city="segment margin-bottom-medium width-45 sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-department="segment margin-bottom-medium width-45 sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
        class-address_public="segment margin-bottom-medium width-10 sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading text-uppercase tzcld-checkbox"
        label-position="Poste occupé"
        label-organisation="Organisation"
        label-address="Adresse"
        label-postal_code="Code postal"
        label-city="Ville"
        label-department="Département"
        label-address_public="Public"
        widget-address_public="solid-form-checkbox-label"
        multiple-phones
        widget-phones="customtzcld-form-profile-phone-widget"
        multiple-phones-label= "Téléphone"
        multiple-phones-add-label= "Ajouter un téléphone"
        multiple-phones-remove-label= "Supprimer"
        multiple-emails
        widget-emails="customtzcld-form-profile-email-widget"
        multiple-phones-label= "Téléphone"
        multiple-emails-add-label= "Ajouter un E-mail"
        multiple-emails-remove-label= "Supprimer"
        multiple-emails-remove-class= "multiple-delete"
        
        widget-department="solid-form-dropdown-label"
        range-department="${dataSrc}tzcld-departments/"

      ></solid-form>
      </template>
      </solid-widget>
      <solid-widget name="customtzcld-form-profile-locations-widget">
      <template>
      <solid-form
      class="d-block rowClear"
      data-src="\${value}"
      data-holder
      naked
      fields="segment11(name), segment12(address, postal_code), segment13(city, department), phones, emails, link, segment14(twitter_link, linkedin_link)"
      value-profile="\${value}"
      class-segment11="segment full sm-full rowClear"
      class-segment12="segment full sm-full rowClear"
      class-segment13="segment full sm-full rowClear"
      class-segment14="segment full sm-full rowClear"
      class-name="segment margin-bottom-medium full sm-full sm-padding-none text-xlarge text-semibold text-color-heading"
      class-address="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
      class-postal_code="segment margin-bottom-medium half sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"
      class-city="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
      class-department="segment margin-bottom-medium half sm-full padding-left-small padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
      
      class-link="segment margin-bottom-medium full sm-full sm-padding-none text-xlarge text-semibold text-color-heading"
      class-twitter_link="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
      class-linkedin_link="segment margin-bottom-medium half sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"

      label-name="Nom de l'adresse"
      label-address="Adresse"
      label-postal_code="Code postal"
      label-city="Ville"
      label-department="Département"
      label-link="URL Site internet"
      label-twitter_link="URL Twitter"
      label-linkedin_link="URL Linkedin"
      multiple-phones
      widget-phones="customtzcld-form-profile-phone-widget"
      multiple-phones-label= "Téléphone"
      multiple-phones-add-label= "Ajouter un téléphone"
      multiple-phones-remove-label= "Supprimer"
      multiple-emails
      widget-emails="customtzcld-form-profile-email-widget"
      multiple-phones-label= "Téléphone"
      multiple-emails-add-label= "Ajouter un E-mail"
      multiple-emails-remove-label= "Supprimer"
      multiple-emails-remove-class= "multiple-delete"
      
      widget-department="solid-form-dropdown-label"
      range-department="${dataSrc}tzcld-departments/"

    ></solid-form>
    </template>
    </solid-widget>`;
        }
      }
    );
  });
});



